trait Polygon {
    fn get_area(&self) -> i32;

    // デフォルトメソッド
    fn is_square(&self) -> bool {
        true
    }
}

struct Rectangle {
    width: i32,
    height: i32,
}

impl Polygon for Rectangle {
    fn get_area(&self) -> i32 {
        self.width * self.height
    }

    fn is_square(&self) -> bool {
        if self.width == self.height {
            true
        } else {
            false
        }
    }
}

struct Square {
    edge: i32,
}

impl Polygon for Square {
    fn get_area(&self) -> i32 {
        self.edge * self.edge
    }
}

fn main() {
    let rect = Rectangle{width: 10, height:20};
    let sq = Square{edge:15};

    println!("rect：面積 = {}, 正方形か否か = {}", rect.get_area(), rect.is_square());
    println!("sq  ：面積 = {}, 正方形か否か = {}", sq.get_area(), sq.is_square());
}