use std::fmt;

struct Rectangle {
    width: i32,
    height: i32,
}

impl fmt::Display for Rectangle {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{} × {}", self.width, self.height)
    }
}

impl fmt::Debug for Rectangle {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "width = {} and height = {}", self.width, self.height)
    }
}

fn main() {
    let rect = Rectangle{width: 10, height: 20};

    println!("rect：{}", rect);
    println!("rect：{:?}", rect);
}