use std::ops::Mul;

struct Rectangle<T> {
    width: T,
    height: T,
}

impl<T> Rectangle<T>
    where T: Mul<Output=T> + Copy {
    fn get_area(&self) -> T {
        self.width * self.height
    }
}

fn main() {
    let rect1 = Rectangle{width: 10, height: 20};
    println!("rect1の面積 = {}", rect1.get_area());

    let rect2 = Rectangle{width: 5.5, height: 22.3};
    println!("rect2の面積 = {}", rect2.get_area());
}